#ifndef PACKET_H_
#define PACKET_H_ 1

enum packet_type
{
  /* Server messages */
  packet_create_game = 0x00,
  packet_join_game = 0x01,
  packet_start_game = 0x02,
  packet_abort_game = 0x03,
  packet_join_random_game = 0x04,
  packet_identify = 0x05,

  /* Client messages */
  packet_movement = 0x10,
};

struct network_mbubble
{
  unsigned char x[4];
  unsigned char y[4];
  unsigned char velx[4];
  unsigned char vely[4];
  unsigned char falling;
  unsigned char color;
};

struct data_packet
{
  unsigned short payload_size;
  unsigned char packet_type;

  union
  {
    struct
    {
      char name[32];
    } create_game;

    struct
    {
      char name[32];
    } join_game;

    struct
    {
      unsigned char seed[4];
      unsigned char other_host[4];
      unsigned char port_lo;
      unsigned char port_hi;
      unsigned char is_server;
    } start_game;

    struct
    {
      char reason[32];
    } abort_game;

    struct
    {
      char game[32];
      unsigned char port_lo;
      unsigned char port_hi;
    } identify;

    struct
    {
      unsigned char angle[4];
      unsigned char flags;
      unsigned char bubbles;

      unsigned char field[53];
      unsigned char mbubble_count;
      struct network_mbubble mbubbles[128];
    } movement;

    unsigned char padding[65535];
  };
};

#endif /* PACKET_H_ */
